using System;
using System.Collections;
using System.IO;
using System.Diagnostics;
using System.Xml.Serialization;
using System.Windows.Forms;

namespace CsCgrep
{
	/// <summary>
	/// CsCgrep̐ݒǗNXłB
	/// </summary>
	public class ApplicationSettings
	{
		/// <summary>
		/// tH_őێB
		/// </summary>
		public const int FOLDER_HISTORY_MAX = 10;

		/// <summary>
		/// ꗚőێB
		/// </summary>
		public const int KEYWORD_HISTORY_MAX = 10;

		/// <summary>
		/// Ώۃt@CőێB
		/// </summary>
		public const int FILENAME_HISTORY_MAX = 10;

		/// <summary>
		/// AvP[V̐ݒ肪ύXꂽǂ\܂B
		/// </summary>
		private bool appSettingsChanged = false;

		/// <summary>
		/// ŌɎQƂtH_łB
		/// </summary>
		private string lastBrowseFolder;

		/// <summary>
		/// tH_̗łB
		/// </summary>
		private ArrayList folderHistories = new ArrayList();

		/// <summary>
		/// ̗łB
		/// </summary>
		private ArrayList keywordHistories = new ArrayList();

		/// <summary>
		/// Ώۃt@C̗łB
		/// </summary>
		private ArrayList fileNameHistories = new ArrayList();

		/// <summary>
		/// EBhE̕
		/// </summary>
		private int windowWidth = 0;

		/// <summary>
		/// EBhE̍
		/// </summary>
		private int windowHeight = 0;

		/// <summary>
		/// EBhEXW
		/// </summary>
		private int windowX = 0;

		/// <summary>
		/// EBhEYW
		/// </summary>
		private int windowY = 0;

		/// <summary>
		/// Iɍő剻Ԃłǂ
		/// </summary>
		private bool isMaximizedOnTerminate = false;

		/// <summary>
		/// TutH_邩ǂ
		/// </summary>
		private bool searchSubFolder = true;

		/// <summary>
		/// 啶ʂ邩ǂ
		/// </summary>
		private bool caseSensitive = false;

		/// <summary>
		/// K\邩ǂ
		/// </summary>
		private bool useRegularExp = false;

		/// <summary>
		/// }b`s̑O̕\s
		/// </summary>
		private int leadingLinesToPrint = 2;

		/// <summary>
		/// }b`š̕\s
		/// </summary>
		private int trailingLinesToPrint = 2;

		/// <summary>
		/// }b`subN̋؂s
		/// </summary>
		private int blankLinesBetweenBlocks = 1;

        /// <summary>
        /// ʏo̓_CAOŃt@CIĂ邩ǂ
        /// </summary>
        private bool fileNameChecked = true;

        /// <summary>
        /// ʏo̓_CAOŏꏊIĂ邩ǂ
        /// </summary>
        private bool placeChecked = false;

        /// <summary>
        /// ʏo̓_CAOōsԍIĂ邩ǂ
        /// </summary>
        private bool lineNumberChecked = true;

        /// <summary>
        /// ʏo̓_CAOœeIĂ邩ǂ
        /// </summary>
        private bool contentsChecked = true;

        /// <summary>
        /// ʏo̓_CAOŃ}[J[񂪑IĂ邩ǂ
        /// </summary>
        private bool markerChecked = true;

        /// <summary>
        /// ʏo̓_CAOŋ؂蕶ɃXy[XIĂ邩ǂ
        /// </summary>
        private bool spaceRadioChecked = true;

        /// <summary>
        /// ʏo̓_CAOŋ؂蕶Ƀ^uIĂ邩ǂ
        /// </summary>
        private bool tabRadioChecked = false;

        /// <summary>
        /// ʏo̓_CAOŋ؂蕶ɃJ}IĂ邩ǂ
        /// </summary>
        private bool commaRadioChecked = false;

        /// <summary>
        /// ʏo̓_CAOŋ؂蕶ɔCӕ񂪑IĂ邩ǂ
        /// </summary>
        private bool anyRadioChecked = false;

        /// <summary>
        /// ʏo̓_CAOœ͂ꂽXy[X̌
        /// </summary>
        private string spaceNum = "3";

        /// <summary>
        /// ʏo̓_CAOœ͂ꂽ^ǔ
        /// </summary>
        private string tabNum = "1";

        /// <summary>
        /// ʏo̓_CAOœ͂ꂽCӕ
        /// </summary>
        private string anyText = "";

        /// <summary>
        /// ʏo̓_CAOœ͂ꂽ}[J[
        /// </summary>
        private string markerText = "***";

        /// <summary>
        /// t@Cǂݍݎ̃GR[fBO
        /// </summary>
        private string inputEncoding = Constants.SHIFT_JIS;

        /// <summary>
        /// t@Cݎ̃GR[fBO
        /// </summary>
        private string outputEncoding = Constants.SHIFT_JIS;

        /// <summary>
        /// OGfB^̃pX
        /// </summary>
        private string externalEditorPath = "";


		public ApplicationSettings()
		{
		}

		/// <summary>
		/// ŌɎQƂtH_łB
		/// </summary>
		public string LastBrowseFolder
		{
			get
			{
				return lastBrowseFolder;
			}
			set
			{
				lastBrowseFolder = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// tH_̗łB
		/// </summary>
		public ArrayList FolderHistories
		{
			get
			{
				return folderHistories;
			}
			set
			{
				folderHistories = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// ̗łB
		/// </summary>
		public ArrayList KeywordHistories
		{
			get
			{
				return keywordHistories;
			}
			set
			{
				keywordHistories = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// Ώۃt@C̗łB
		/// </summary>
		public ArrayList FileNameHistories
		{
			get
			{
				return fileNameHistories;
			}
			set
			{
				fileNameHistories = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// EBhE̕
		/// </summary>
		public int WindowWidth
		{
			get
			{
				return windowWidth;
			}
			set
			{
				windowWidth = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// EBhE̍
		/// </summary>
		public int WindowHeight
		{
			get
			{
				return windowHeight;
			}
			set
			{
				windowHeight = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// EBhEXW
		/// </summary>
		public int WindowX
		{
			get
			{
				return windowX;
			}
			set
			{
				windowX = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// EBhEYW
		/// </summary>
		public int WindowY
		{
			get
			{
				return windowY;
			}
			set
			{
				windowY = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// Iɍő剻Ԃłǂ
		/// </summary>
		public bool IsMaximizedOnTerminate
		{
			get
			{
				return isMaximizedOnTerminate;
			}
			set
			{
				isMaximizedOnTerminate = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// TutH_邩ǂ
		/// </summary>
		public bool SearchSubFolder
		{
			get
			{
				return searchSubFolder;
			}
			set
			{
				searchSubFolder = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// 啶ʂ邩ǂ
		/// </summary>
		public bool CaseSensitive
		{
			get
			{
				return caseSensitive;
			}
			set
			{
				caseSensitive = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// K\邩ǂ
		/// </summary>
		public bool UseRegularExpressions
		{
			get
			{
				return useRegularExp;
			}
			set
			{
				useRegularExp = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// }b`s̑O̕\s
		/// </summary>
		public int LeadingLinesToPrint
		{
			get
			{
				return leadingLinesToPrint;
			}
			set
			{
				leadingLinesToPrint = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// }b`š̕\s
		/// </summary>
		public int TrailingLinesToPrint
		{
			get
			{
				return trailingLinesToPrint;
			}
			set
			{
				trailingLinesToPrint = value;
				appSettingsChanged = true;
			}
		}

		/// <summary>
		/// }b`subN̋؂s
		/// </summary>
		public int BlankLinesBetweenBlocks
		{
			get
			{
				return blankLinesBetweenBlocks;
			}
			set
			{
				blankLinesBetweenBlocks = value;
				appSettingsChanged = true;
			}
		}

        /// <summary>
        /// ʏo̓_CAOŃt@CIĂ邩ǂ
        /// </summary>
        public bool FileNameChecked
        {
            get
            {
                return fileNameChecked;
            }
            set
            {
                fileNameChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOŏꏊIĂ邩ǂ
        /// </summary>
        public bool PlaceChecked
        {
            get
            {
                return placeChecked;
            }
            set
            {
                placeChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOōsԍIĂ邩ǂ
        /// </summary>
        public bool LineNumberChecked
        {
            get
            {
                return lineNumberChecked;
            }
            set
            {
                lineNumberChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOœeIĂ邩ǂ
        /// </summary>
        public bool ContentsChecked
        {
            get
            {
                return contentsChecked;
            }
            set
            {
                contentsChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOŋ؂蕶ɃXy[XIĂ邩ǂ
        /// </summary>
        public bool SpaceRadioChecked
        {
            get
            {
                return spaceRadioChecked;
            }
            set
            {
                spaceRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOŋ؂蕶Ƀ^uIĂ邩ǂ
        /// </summary>
        public bool TabRadioChecked
        {
            get
            {
                return tabRadioChecked;
            }
            set
            {
                tabRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOŋ؂蕶ɃJ}IĂ邩ǂ
        /// </summary>
        public bool CommaRadioChecked
        {
            get
            {
                return commaRadioChecked;
            }
            set
            {
                commaRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOŋ؂蕶ɔCӕ񂪑IĂ邩ǂ
        /// </summary>
        public bool AnyRadioChecked
        {
            get
            {
                return anyRadioChecked;
            }
            set
            {
                anyRadioChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOœ͂ꂽXy[X̌
        /// </summary>
        public string SpaceNum
        {
            get
            {
                return spaceNum;
            }
            set
            {
                spaceNum = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOœ͂ꂽ^ǔ
        /// </summary>
        public string TabNum
        {
            get
            {
                return tabNum;
            }
            set
            {
                tabNum = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOœ͂ꂽCӕ
        /// </summary>
        public string AnyText
        {
            get
            {
                return anyText;
            }
            set
            {
                anyText = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOŃ}[J[񂪑IĂ邩ǂ
        /// </summary>
        public bool MarkerChecked
        {
            get
            {
                return markerChecked;
            }
            set
            {
                markerChecked = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// ʏo̓_CAOœ͂ꂽ}[J[
        /// </summary>
        public string MarkerText
        {
            get
            {
                return markerText;
            }
            set
            {
                markerText = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// t@Cǂݍݎ̃GR[fBO
        /// </summary>
        public string InputEncoding
        {
            get
            {
                return inputEncoding;
            }
            set
            {
                inputEncoding = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// t@Cݎ̃GR[fBO
        /// </summary>
        public string OutputEncoding
        {
            get
            {
                return outputEncoding;
            }
            set
            {
                outputEncoding = value;
                appSettingsChanged = true;
            }
        }

        /// <summary>
        /// OGfB^̃pX
        /// </summary>
        public string ExternalEditorPath
        {
            get
            {
                return externalEditorPath;
            }
            set
            {
                externalEditorPath = value;
                appSettingsChanged = true;
            }
        }

		/// <summary>
		/// tH_̓͗ǉ܂B
		/// </summary>
		/// <param name="folder">ǉtH_</param>
		public void AddFolderHistory(string folder)
		{
			// ɓtH_邩ǂ𒲂ׂ
			if (folderHistories.Contains(folder))
			{
				// ݂̃CfbNX擾
				int index = folderHistories.IndexOf(folder);

				// ݂̈ʒuɂtH_폜
				folderHistories.RemoveAt(index);
			}

			// ̐擪ɒǉ
			folderHistories.Insert(0, folder);

			appSettingsChanged = true;

			// ͗ێ𒴂ꍇ
			if(folderHistories.Count > FOLDER_HISTORY_MAX)
			{
				// Xg̍Ō̗vf폜
				folderHistories.RemoveAt(
					folderHistories.Count - 1);
			}
		}

        /// <summary>
        /// tH_̓͗NA܂B
        /// </summary>
        public void ClearFolderHistory()
        {
            folderHistories.Clear();

            appSettingsChanged = true;
        }

		/// <summary>
		/// ̓͗ǉ܂B
		/// </summary>
		/// <param name="folder">ǉ錟</param>
		public void AddKeywordHistory(string keyword)
		{
			// ɓtH_邩ǂ𒲂ׂ
			if (keywordHistories.Contains(keyword))
			{
				// ݂̃CfbNX擾
				int index = keywordHistories.IndexOf(keyword);

				// ݂̈ʒuɂtH_폜
				keywordHistories.RemoveAt(index);
			}

			// ̐擪ɒǉ
			keywordHistories.Insert(0, keyword);

			appSettingsChanged = true;

			// ͗ێ𒴂ꍇ
			if(keywordHistories.Count > KEYWORD_HISTORY_MAX)
			{
				// Xg̍Ō̗vf폜
				keywordHistories.RemoveAt(
					keywordHistories.Count - 1);
			}
		}

        /// <summary>
        /// ̓͗NA܂B
        /// </summary>
        public void ClearKeywordHistory()
        {
            keywordHistories.Clear();

            appSettingsChanged = true;
        }

		/// <summary>
		/// Ώۃt@C̓͗ǉ܂B
		/// </summary>
		/// <param name="folder">ǉt@C</param>
		public void AddFileNameHistory(string fileName)
		{
			// ɓt@C邩ǂ𒲂ׂ
			if (fileNameHistories.Contains(fileName))
			{
				// ݂̃CfbNX擾
				int index = fileNameHistories.IndexOf(fileName);

				// ݂̈ʒuɂt@C폜
				fileNameHistories.RemoveAt(index);
			}

			// ̐擪ɒǉ
			fileNameHistories.Insert(0, fileName);

			appSettingsChanged = true;

			// ͗ێ𒴂ꍇ
			if(fileNameHistories.Count > KEYWORD_HISTORY_MAX)
			{
				// Xg̍Ō̗vf폜
				fileNameHistories.RemoveAt(
					fileNameHistories.Count - 1);
			}
		}

        /// <summary>
        /// t@C̓͗NA܂B
        /// </summary>
        public void ClearFileNameHistory()
        {
            fileNameHistories.Clear();

            appSettingsChanged = true;
        }

		/// <summary>
		/// ύXĂݒ肪ꍇANX\t@C
		/// VA܂B
		/// </summary>
		/// <returns>ύXĂݒ肪ꍇtrue,Ȃꍇfalse</returns>
		public bool SaveAppSettings()
		{
			if(this.appSettingsChanged)
			{
				StreamWriter myWriter = null;
				XmlSerializer mySerializer = null;

				try
				{
					// ApplicationSettings ^
					// XmlSerializer 쐬܂B
					mySerializer = new XmlSerializer(typeof(ApplicationSettings));
					myWriter = 
						new StreamWriter(
						Application.StartupPath	+ @"\cscgrepcfg.xml", false);

					// ApplicationSettings NX̂̃CX^X
					// \t@CɃVA܂B
					mySerializer.Serialize(myWriter, this);
				}
				catch(Exception ex)
				{
					Debug.WriteLine(ex.Message);
					Debug.WriteLine(ex.StackTrace);

					MessageUtil.ShowAlert("CsCgrep̐ݒ݂̏Ɏs܂B");
				}
				finally
				{
					// FileStream JĂꍇ͕܂B
					if(myWriter != null)
					{
						myWriter.Close();
					}
				}
			}

			return appSettingsChanged;
		}

		/// <summary>
		/// \t@CNXVA܂B
		/// </summary>
		/// <returns>\t@Cꍇtrue,łȂꍇfalse</returns>
		public bool LoadAppSettings()
		{
			XmlSerializer mySerializer = null;
			FileStream myFileStream = null;
			bool fileExists = false;

			try
			{
				// ApplicationSettings ^ XmlSerializer 쐬܂B
				mySerializer = new XmlSerializer(typeof(ApplicationSettings));
				FileInfo fi = new FileInfo(
                    Application.StartupPath + @"\cscgrepcfg.xml");

				// \t@C݂ꍇ́AJ܂B
				if(fi.Exists)
				{
					myFileStream = fi.OpenRead();
					// \t@CVA邱ƂɂA
					// ApplicationSettings ̐VKCX^X쐬܂B
					ApplicationSettings myAppSettings = 
						(ApplicationSettings)mySerializer.Deserialize(
						myFileStream);
					// ApplicationSettings NX̂̃CX^X
					// vpeBl蓖Ă܂B
					this.lastBrowseFolder = myAppSettings.lastBrowseFolder;
					this.folderHistories = myAppSettings.folderHistories;
					this.keywordHistories = myAppSettings.keywordHistories;
					this.fileNameHistories = myAppSettings.fileNameHistories;
					this.windowHeight = myAppSettings.windowHeight;
					this.windowWidth = myAppSettings.windowWidth;
					this.windowX = myAppSettings.windowX;
					this.windowY = myAppSettings.windowY;
					this.isMaximizedOnTerminate = myAppSettings.isMaximizedOnTerminate;
					this.searchSubFolder = myAppSettings.searchSubFolder;
					this.caseSensitive = myAppSettings.caseSensitive;
					this.useRegularExp = myAppSettings.useRegularExp;
					this.leadingLinesToPrint = myAppSettings.leadingLinesToPrint;
					this.trailingLinesToPrint = myAppSettings.trailingLinesToPrint;
					this.blankLinesBetweenBlocks = myAppSettings.blankLinesBetweenBlocks;
                    this.fileNameChecked = myAppSettings.fileNameChecked;
                    this.placeChecked = myAppSettings.placeChecked;
                    this.lineNumberChecked = myAppSettings.lineNumberChecked;
                    this.contentsChecked = myAppSettings.contentsChecked;
                    this.spaceRadioChecked = myAppSettings.spaceRadioChecked;
                    this.tabRadioChecked = myAppSettings.tabRadioChecked;
                    this.commaRadioChecked = myAppSettings.commaRadioChecked;
                    this.anyRadioChecked = myAppSettings.anyRadioChecked;
                    this.spaceNum = myAppSettings.spaceNum;
                    this.tabNum = myAppSettings.tabNum;
                    this.anyText = myAppSettings.anyText;
                    this.markerChecked = myAppSettings.markerChecked;
                    this.markerText = myAppSettings.markerText;
                    this.inputEncoding = myAppSettings.inputEncoding;
                    this.outputEncoding = myAppSettings.outputEncoding;
                    this.externalEditorPath = myAppSettings.externalEditorPath;

					fileExists = true;
				}
			}
			catch(Exception ex)
			{
				Debug.WriteLine(ex.Message);
				Debug.WriteLine(ex.StackTrace);

				MessageUtil.ShowAlert("CsCgrep̐ݒ̓ǂݍ݂Ɏs܂B");
			}
			finally
			{
				// FileStream JĂꍇ͕܂B
				if(myFileStream != null)
				{
					myFileStream.Close();
				}
			}

			return fileExists;
		}
	}
}
